float4x4 WorldViewProjection;
Texture ColoredTexture;

sampler ColoredTextureSampler = sampler_state 
{
	texture = <ColoredTexture>;
	magFilter = LINEAR; // ??
	minFilter = LINEAR; // ??
	mipFilter = LINEAR; // ??
	AddressU = mirror;  // ??
	AddressV = mirror;  // ??
};


struct VertexShaderInput
{
    float4 Position : POSITION0;
    float2 textureCoordinates : TEXCOORD0;

    // TODO: add input channels such as texture
    // coordinates and vertex colors here.
};

struct VertexShaderOutput
{
    float4 Position : POSITION0;
    float2 textureCoordinates : TEXCOORD0;

    // TODO: add vertex shader outputs such as colors and texture
    // coordinates here. These values will automatically be interpolated
    // over the triangle, and provided as input to your pixel shader.
};

VertexShaderOutput VertexShaderFunction(VertexShaderInput input)
{
    VertexShaderOutput output 
		= (VertexShaderOutput)0;  // Why the assignment?

    output.Position = mul(input.Position, WorldViewProjection);
    output.textureCoordinates = input.textureCoordinates;

    // TODO: add your vertex shader code here.

    return output;
}

float4 PixelShaderFunction(VertexShaderOutput input) : COLOR0
{
    // TODO: add your pixel shader code here.

    return 
		(tex2D(ColoredTextureSampler, input.textureCoordinates)
		+ tex2D(ColoredTextureSampler, input.textureCoordinates.xy + 0.01)
		+ tex2D(ColoredTextureSampler, input.textureCoordinates.xy - 0.01))
		/ 3;
}

technique Textured
{
    pass Pass1
    {
        // TODO: set renderstates here.

        VertexShader = compile vs_1_1 VertexShaderFunction();
        PixelShader = compile ps_2_0 PixelShaderFunction();
    }
}
